Program Ovladani_Modulu;
Uses Dos;
Var ExpHodnota :Array[0..5500] of Byte; BIOSTimerHandler :Procedure;
clock_ticks,counter :LongInt;
MaskInt :Byte;
Pocet_prubehu :LongInt;

PROCEDURE SetTimer(TimerHandler:Pointer;Frequency:Word);
BEGIN
 Pocet_prubehu:=0;
 clock_ticks :=0;
 counter :=$1234DD div Frequency; {vycisleni deliciho pomeru}
 MaskInt:=Port[$21]; {nacteni masky preruseni}
 Port[$21]:=$0FE; {zakaz vech preruseni vyjma IRQ8}
 GetIntVec(8, @BIOSTimerHandler); {nacteni ukazatele IRQ8}
 SetIntVec(8, TimerHandler); {prestaveni ukazatele IRQ8}
 Port[$43]:=$34; {prestaveni systemoveho casovace}
 Port[$40]:=counter mod 256;
 Port[$40]:=counter div 256
END;

PROCEDURE CleanUpTimer;
BEGIN
 Port[$43]:=$34; {prestaveni casovace na puvodni hodnotu}
 Port[$40]:=0;
 Port[$40]:=0;
 Port[$21]:=MaskInt; {zpetne nastaveni stare masky IRQ}
 SetIntVec(8, @BIOSTimerHandler) {nastaveni puvodni IRQ8}
END;

PROCEDURE StartAD;
BEGIN
 Port[$37A]:=Port[$37A] AND 254; {STROBE na logickou 1}
 Port[$37a]:=Port[$37a] OR 1; {setupna hrana na STROBE}
 Port[$37a]:=Port[$37a] AND 254 {vzestupna hrana na -//-; start AD}
END;

FUNCTION ReadAD: Byte;
BEGIN
 ReadAd:=Port[$378] {cteni datovych vodicu paral. portu}
END;

{$F+}
PROCEDURE Handler; Interrupt; {nova procedura IRQ8}
BEGIN
 clock_ticks:=clock_ticks+counter; {pocitani tiku frekvence 1,9MHz}
 If Pocet_prubehu=0 Then StartAD {poprve jen spusti AD prevodnik}
  Else Begin {jinak nacti, pak pust AD}
         ExpHodnota[Pocet_prubehu]:=ReadAD;
         StartAD
        End;
 inc(Pocet_prubehu);
 if clock_ticks=$10000 Then Begin 
         {jestlize probehne 65536 tiku spust puvodni rutinu IRQ8}
				clock_ticks:=clock_ticks-$10000;
				asm pushf end;
				BIOSTimerHandler
			End
			Else Port[$20]:=$20 
			{ukonceni IRQ rutiny}
END;
{$F-}

{---------------------H-L-A-V-N-I----P-R-O-G-R-A-M------------------}

BEGIN
 ClrScr;
 Port[$37A]:=Port[$37A] OR 32; {potvrdit oboustrannou komunikaci}
 Port[$37A]:=Port[$37A] OR 2; {pripojit vystupy A/D ze 3 stavu}
 WriteLn('Nacitam data...');
 SetTimer(Addr(Handler),33144); {inicializace nacitani}
 Repeat
 Until Pocet_Prubehu=5000;
 CleanUpTimer;
 Port[$37A]:=Port[$37A] AND 253; {vystupy A/D zpet do tretiho stavu}
 WriteLn('O.K. data namerena')
END.
